## 先导入必要的包
import requests
import pandas as pd
import json
import time


TIMEOUT = 10
headers = {"Referer":"https://wanwang.aliyun.com/domain/reserve",
       "user-agent":"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) Apple: WebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.125 Safari/537.36",
       } 
def get_token():
    tokenurl = "https://promotion.aliyun.com/risk/getToken.htm"
    text = requests.get(tokenurl,headers=headers).text
    return json.loads(text)["data"]

def get_domains(token,regd="2000"):

### 这里根据参数直接修改就行，我设置的是一页100条记录，也就是100个域名，查看第一页就好了
### 后缀 com，域名长度最大为5，返回设置为json
    url = "https://domainapi.aliyun.com/preDelete/search.jsonp?keyWord=&excludeKeyWord=&keywordAsPrefix=false&keywordAsSuffix=false&exKeywordAsPrefix=fa\
lse&exKeywordAsSuffix=false&constitute=5&suffix=com&domainType=&endDate=&regDate={}&pageSize=200&currentPage=1&bookStatus=false&reserveRmb=&sortBy=1&pa\
tnerTypes=&sortType=1&_t=self&minLength=&maxLength=10&minPrice=&maxPrice=&token=tdomain-aliyun-com%3A{}&callback=json".format(regd,token)
    text = requests.get(url,headers=headers,timeout = TIMEOUT).text
#根据json结构获取内容
    domains = json.loads(text.split("(")[1].split(")")[0])  
    return domains

## 这里手动添加token

token = "Y15a564fc4ed081a18a64aa9b0ccc23bb" 
## 这里通过阿里的api自动获取token
token = get_token() 
print(token)

## 搜索到的域名保存文件名
filename = "ali_domain.tsv"
## 每次运行是更新文件内容
with open("ali_domain.tsv",'w') as fw:
    fw.close()


# 从2006年到2010 年逐年搜索并写入到csv文件
for i in range(2000,2023):

    domains = get_domains(token,regd=str(i))
    if domains["code"]=="200":
        domains = domains["data"]["pageResult"]["data"]
        domains = pd.DataFrame.from_dict(domains)
        domains = domains[~domains.short_name.str.contains("-")] 
        print(domains)
        domains.to_csv(filename,index=None,mode="a",sep="\t")
    time.sleep(20)
